"""
    MoinMoin - ExportPage action

    Based on the CreatePdf action by Alexander Bormann

    Based on the CommentPage action by Robert Seeger

    Based on the DeletePage action by Jrgen Hermann <jh@web.de>

    A hack of the RenamPage action that is Copyright (c) 2002 Michael Reinsch <mr@uue.org>
    All rights reserved, see COPYING for details.


    This action allows you to export the actual page to any supported export format

    $Id$
    ORS modifications:
        13.09.05 ABP
        02.03.06 ABP minor changes
"""

# Imports
import string, time,sys,os,copy
from MoinMoin import user, webapi, wikiutil
from MoinMoin.PageEditor import PageEditor
from MoinMoin.script.export.export import PluginScript as MoinExporter

selection_fields = {
    'exporttype':{'type':'radiofield','labels':[
    ('', '--undefined--'),
    ('pdf', 'PDF file'),
#    ('word', 'MS Word file'),
    ('html', 'HTML file for use in CHM'),
    ('hhc', 'CHM TOC file'),
    ('hhk', 'CHM Index file'),
    ('plain', 'Plain text'),
]}}

formhtml = """
<form method="POST" action="%(scriptname)s%(pathinfo)s">
<input type="hidden" name="action" value="%(actname)s">
<form method="post" action="">

<input type="hidden" name="pass" value="1">
<table border=0>
<colgroup>
<col width="40">
<col width="190">
<col width="40">
<col width="120">
</colgroup>
<tr>
<td>%(newauthor_label)s</td>
<td colspan="3"><input type="text" name="newauthor" size="20" value="%(newauthor)s" readonly></td>
</tr>
<tr><td><b>%(label_exporttype)s</b>&nbsp;</td><td>
  %(exporttype_select)s
</td></tr>
<tr>
<tr><td>&nbsp;</td><td>
<input type="checkbox" name="debug" value="1" >%(debug_label)s
</td></tr>
<tr>
<td height="15" colspan ="4"> </td>
</tr>
<tr>
<td colspan="2" align="center"><input type="submit" name="button1" value="%(button1)s"></td>
<td></td>
<td></td>
</tr>
</table>


</form>"""


def execute(pagename, request):
    '''
    Execute the CreatePage action.

    @param pagename: name of the wikipage, where the action was startet
    @type pagename: unicode
    @param request: an object of RequestORSCGI
    @type request: classobject
    @return: wikipage with the pdf (or error.log) link
    @rtype: C{page.send_page}
    '''
#RS 1.1.
    _ = request.getText
#RS stop
    sys.path.append('D:\\Programme\\Microsoft Office\\Office')            # necessary binary files are here
    actname = string.split(__name__, '.')[-1]
    action_pass=u"-1"
    page = PageEditor(request,pagename)
    if request.form.has_key("pass") :
        action_pass=",".join(request.form.get("pass",[u"-99"]))
    if action_pass==u"1":
        
    
    #RS continue
        exp_format=request.form.get("exporttype",[u"pdf"])[0]
        remote_debug=request.form.get("debug",['0'])[0]
        if remote_debug=='1':
            request.startRemoteDebugger() 
    #must protect a function that is overrided by the exporter
        qfn_orig=wikiutil.quoteWikinameURL
        markup_orig=request.cfg.default_markup
        stdout_orig=sys.stdout
        
        exporter=MoinExporter()
        exporter.request=copy.copy(request)
        exporter.request.initTheme()
        exporter.setOutputDir(request.cfg.export_prefix_dir+"\\"+exp_format)
        downloadlink=request.cfg.export_prefix+"/"+exp_format
        exporter.request.user.show_topbottom=0
        exporter.request.form['action']=['print']
        exporter.request.form['export']=['1']
        exporter.request.form['media']=['export']
        exporter.setFormatter(exp_format)
        if exp_format in (u"word",u"pdf"):    
            request.cfg.default_markup="wiki_word"
#            stdoutfile = os.path.join(exporter.outputdir, 'stdout.log')
#            sys.stdout = open(stdoutfile, 'w')
        
        exporter.request.export_mode=1
        errfile_name='%s_error.txt' % exporter.doctype
        errfile = os.path.join(exporter.outputdir, errfile_name)
        exporter.errlog = open(errfile, 'w')
        errcnt = 0
        exptitle = wikiutil.quoteWikinameFS(pagename)
        file = exptitle + exporter.ext
    # output is a string with embedded tags; now only usefull for testing
        output=exporter.dumpPage(pagename,file)
        exporter.errlog.close()
        expfile = exptitle + "."+exporter.doctype
        expfilepath = os.path.abspath(os.path.join(exporter.outputdir, expfile))

    #reset overrided function
        wikiutil.quoteWikinameURL = qfn_orig
        request.cfg.default_markup=markup_orig
#        sys.stdout.close()
        sys.stdout = stdout_orig

        request.form['action']=['show']
        request.form['export']=['0']

    #use this to test output
    #    return page.send_page(request,        msg='<pre>%s</pre>' % output)

        f= open(errfile,'r')
        if f.readline()=='':
            f.close()
            return page.send_page(request,
                msg='<strong>%s</strong>' %
                    _('Export of page %(page)s to format <i>%(exp_format)s</i> completed.<br><br><a href="%(link)s/%(file)s">Link to exported file</a><br><br>' 
                       )%{'page':pagename, 'exp_format':exp_format,'link':downloadlink,'file':expfile})
        else:
            f.close()
            return page.send_page(request,
                msg='<strong>%s</strong>' %
                    _('Error while exporting page %(page)s.<br><br>See <a href="%(link)s/%(errlog)s">%(errlog)s</a> for further details.  <br>If you are an expert, you may also want to look at the <a href="%(link)s/%(rawout)s"> formatter debug output</a>.<br>'
                       )%{'page':pagename, 'link':downloadlink,'errlog':errfile_name,'rawout':file})

# step1: send first form
    newauthor="NoName"
    try:
        newauthor=request.user.name
    except:
        pass
    data={
        'exporttype':'pdf',
        'label_exporttype':_("Export format"),
        'newauthor':newauthor,
        'newauthor_label' : _("Author : "),
        'debug_label' : _("Enable remote debugging with WinPDB (experts only)"),
        'scriptname': request.getScriptname(),
#        'thispage':string.split(str(request.getPathinfo()),"/")[1],
        'thispage':string.split(request.getPathinfo(),"/")[1],
        'pathinfo': request.getPathinfo(),
        'actname':actname,
        'button1': _(' Export Page '),
#    button2 = _('Export')

        }
    for key,selector in selection_fields.items():
        ftype=selector['type']
        labels=selector['labels']
        cellvalue=data[key]
        cellhtml=""
        if ftype=='combobox':
            cellhtml=combobox_html(key,labels,cellvalue)
        elif ftype=='radiofield':
            cellhtml=radiofield_html(key,labels,cellvalue)
        data[key+'_select']=cellhtml
    finalform=formhtml % data
    return page.send_page(request, msg=finalform)

#HTML helpers
def combobox_html(comboname,optionlist,currentvalue):
    """
    HTML coding for a "combobox" field with field name, optionlist(list(value,description)) and currentvalue 
    """
    html = '<select name="%s">\n' % comboname
    for opt,opttext in optionlist:
        html+='<option value="%s" %s>%s\n' % (
           opt, opt == currentvalue and ' SELECTED' or '',opttext)
    html = html + '</select>'
 
    return html
    
def radiofield_html(radioname,optionlist,currentvalue):
    """
    HTML coding for a "radiobutton" field with field name, optionlist(list(value,description)) and currentvalue 
    """
    html = '<p>'
    for opt,opttext in optionlist:
        html+= '<input type="radio" name="%s" value="%s" %s>%s<p>' % (
           radioname,opt, opt == currentvalue and ' CHECKED' or '',opttext)
    html = html + '</p>'
 
    return html
        